//
//Service Control Manager
//椸Ѧ winsvc.h
//
 
using System;
using System.Runtime.InteropServices;
 
namespace myServiceTools
{
 //
 //L
 //
 [Flags]
 public enum OtherParm : uint
 {
  STANDARD_RIGHTS_REQUIRED  = 0xF0000,
  SERVICE_NO_CHANGE         = 0xFFFFFFFF,  //Value to indicate no change to an optional parameter
  ERROR_INSUFFICIENT_BUFFER = 122
 }
 //
 //\]ƶiŪgOpenSCManagerưѦҥ
 //
 [Flags]
 public enum DesiredAccess : uint
 {
  GENERIC_READ    = 0x80000000,
  GENERIC_WRITE   = 0x40000000,
  GENERIC_EXECUTE = 0x20000000
 }
 
 //
 //Service State -- for Enum Requests (Bit Mask)
 //
 [Flags]
 public enum ServiceStateRequest:uint
 {
  SERVICE_ACTIVE         = 0x00000001,
  SERVICE_INACTIVE       = 0x00000002,
  SERVICE_STATE_ALL      = (SERVICE_ACTIVE | SERVICE_INACTIVE)
 }
 //
 //Controls
 //
 [Flags]
 public enum ServiceControlType : uint
 {
  SERVICE_CONTROL_STOP                   = 0x00000001,
  SERVICE_CONTROL_PAUSE                  = 0x00000002,
  SERVICE_CONTROL_CONTINUE               = 0x00000003,
  SERVICE_CONTROL_INTERROGATE            = 0x00000004,
  SERVICE_CONTROL_SHUTDOWN               = 0x00000005,
  SERVICE_CONTROL_PARAMCHANGE            = 0x00000006,
  SERVICE_CONTROL_NETBINDADD             = 0x00000007,
  SERVICE_CONTROL_NETBINDREMOVE          = 0x00000008,
  SERVICE_CONTROL_NETBINDENABLE          = 0x00000009,
  SERVICE_CONTROL_NETBINDDISABLE         = 0x0000000A,
  SERVICE_CONTROL_DEVICEEVENT            = 0x0000000B,
  SERVICE_CONTROL_HARDWAREPROFILECHANGE  = 0x0000000C,
  SERVICE_CONTROL_POWEREVENT             = 0x0000000D,
  SERVICE_CONTROL_SESSIONCHANGE          = 0x0000000E
 }
 //
 //Service State -- for CurrentState
 //
 [Flags]
 public enum ServiceState : uint
 {
  SERVICE_STOPPED          = 0x00000001,
  SERVICE_START_PENDING    = 0x00000002,
  SERVICE_STOP_PENDING     = 0x00000003,
  SERVICE_RUNNING          = 0x00000004,
  SERVICE_CONTINUE_PENDING = 0x00000005,
  SERVICE_PAUSE_PENDING    = 0x00000006,
  SERVICE_PAUSED           = 0x00000007
 }
 //
 //Controls Accepted  (Bit Mask)
 //
 [Flags]
 public enum ServiceControlAccepted : uint
 {
  SERVICE_ACCEPT_STOP                   = 0x00000001,
  SERVICE_ACCEPT_PAUSE_CONTINUE         = 0x00000002,
  SERVICE_ACCEPT_SHUTDOWN               = 0x00000004,
  SERVICE_ACCEPT_PARAMCHANGE            = 0x00000008,
  SERVICE_ACCEPT_NETBINDCHANGE          = 0x00000010,
  SERVICE_ACCEPT_HARDWAREPROFILECHANGE  = 0x00000020,
  SERVICE_ACCEPT_POWEREVENT             = 0x00000040,
  SERVICE_ACCEPT_SESSIONCHANGE          = 0x00000080
 }
 //
 //Service Control Manager (specific access rights for the SCM)
 //:Service Control Manager object specific access types
 //
 [Flags]
 public enum ServiceControlManagerType : uint
 {
  SC_MANAGER_CONNECT             =0x0001,
  SC_MANAGER_CREATE_SERVICE      =0x0002,
  SC_MANAGER_ENUMERATE_SERVICE   =0x0004,
  SC_MANAGER_LOCK                =0x0008,
  SC_MANAGER_QUERY_LOCK_STATUS   =0x0010,
  SC_MANAGER_MODIFY_BOOT_CONFIG  =0x0020,
  SC_MANAGER_ALL_ACCESS          = (OtherParm.STANDARD_RIGHTS_REQUIRED  |
                                    SC_MANAGER_CONNECT                  |
                                    SC_MANAGER_CREATE_SERVICE           |
                                    SC_MANAGER_ENUMERATE_SERVICE        |
                                    SC_MANAGER_LOCK                     |
                                    SC_MANAGER_QUERY_LOCK_STATUS        |
                                    SC_MANAGER_MODIFY_BOOT_CONFIG)
 }
 //
 //Service Object(specific access rights for a service)
 //:Service object specific access type
 //
 [Flags]
 public enum ACCESS_TYPE : uint
 {
  SERVICE_QUERY_CONFIG         = 0x0001,
  SERVICE_CHANGE_CONFIG        = 0x0002,
  SERVICE_QUERY_STATUS         = 0x0004,
  SERVICE_ENUMERATE_DEPENDENTS = 0x0008,
  SERVICE_START                = 0x0010,
  SERVICE_STOP                 = 0x0020,
  SERVICE_PAUSE_CONTINUE       = 0x0040,
  SERVICE_INTERROGATE          = 0x0080,
  SERVICE_USER_DEFINED_CONTROL = 0x0100,
  DELETE                       = 0x10000,
  SERVICE_ALL_ACCESS           = (OtherParm.STANDARD_RIGHTS_REQUIRED     |  //GG0xF01FF
                                  SERVICE_QUERY_CONFIG                   |
                                  SERVICE_CHANGE_CONFIG                  |
                                  SERVICE_QUERY_STATUS                   |
                                  SERVICE_ENUMERATE_DEPENDENTS           |
                                  SERVICE_START                          |
                                  SERVICE_STOP                           |
                                  SERVICE_PAUSE_CONTINUE                 |
                                  SERVICE_INTERROGATE                    |
                                  SERVICE_USER_DEFINED_CONTROL)  
 }
 //
 //Service Types (Bit Mask)
 //
 [Flags]
 public enum ServiceType : uint
 {
  SERVICE_KERNEL_DRIVER       = 0x00000001,
  SERVICE_FILE_SYSTEM_DRIVER  = 0x00000002,
  SERVICE_ADAPTER             = 0x00000004,
  SERVICE_RECOGNIZER_DRIVER   = 0x00000008,
  
  SERVICE_DRIVER              = (SERVICE_KERNEL_DRIVER      |
                                 SERVICE_FILE_SYSTEM_DRIVER |
                                 SERVICE_RECOGNIZER_DRIVER) ,
  
  SERVICE_WIN32_OWN_PROCESS   = 0x00000010,
  SERVICE_WIN32_SHARE_PROCESS = 0x00000020,
  
  SERVICE_WIN32               = (SERVICE_WIN32_OWN_PROCESS |
                                 SERVICE_WIN32_SHARE_PROCESS),
  
  SERVICE_INTERACTIVE_PROCESS = 0x00000100,
  
  SERVICETYPE_NO_CHANGE       = OtherParm.SERVICE_NO_CHANGE,
  
  SERVICE_TYPE_ALL            = (SERVICE_WIN32   |
                                 SERVICE_ADAPTER |
                                 SERVICE_DRIVER  |
                                 SERVICE_INTERACTIVE_PROCESS)
 }
 //
 //Start Type
 //
 [Flags]
 public enum ServiceStartType : uint
 {
  SERVICE_BOOT_START   = 0x00000000,
  SERVICE_SYSTEM_START = 0x00000001,
  SERVICE_AUTO_START   = 0x00000002,
  SERVICE_DEMAND_START = 0x00000003,
  SERVICE_DISABLED     = 0x00000004
 }
 //
 //Error control type
 //
 [Flags]
 public enum ServiceErrorControl : uint
 {
  SERVICE_ERROR_IGNORE  = 0x00000000,
  SERVICE_ERROR_NORMAL  = 0x00000001,
  SERVICE_ERROR_SEVERE  = 0x00000002,
  SERVICE_ERROR_CRITICAL= 0x00000003  
 }
 //
 //Actions to take on service failure
 //
 [Flags]
 public enum SC_ACTION_TYPE:uint
 {
  SC_ACTION_NONE        = 0,
  SC_ACTION_RESTART     = 1,
  SC_ACTION_REBOOT      = 2,
  SC_ACTION_RUN_COMMAND = 3
 }
 //
 //Info levels for ChangeServiceConfig2 and QueryServiceConfig2
 //
 [Flags]
 public enum InfoLevel:uint
 {
  SERVICE_CONFIG_DESCRIPTION     = 1,
  SERVICE_CONFIG_FAILURE_ACTIONS = 2
 }
 public class WinSvc
 {
  
  //********************************************************************************
  //
  //Service Status Structure
  //
  [StructLayout(LayoutKind.Sequential)]
  public struct SERVICE_STATUS
  {
   uint  dwServiceType;
   uint  dwCurrentState;
   uint  dwControlsAccepted;
   uint  dwWin32ExitCode;
   uint  dwServiceSpecificExitCode;
   uint  dwCheckPoint;
   uint  dwWaitHint;
  }
  //
  //Service Status Enumeration Structure
  //
  [StructLayout(LayoutKind.Sequential)]
  public struct ENUM_SERVICE_STATUS
  {
   string             lpServiceName;
   string             lpDisplayName;
   SERVICE_STATUS     ServiceStatus;
  }
  //
  //Query Service Configuration Structure
  //
  [StructLayout(LayoutKind.Sequential)]
  public struct QUERY_SERVICE_CONFIG
  {
   uint      dwServiceType;
   uint      dwStartType;
   uint      dwErrorControl;
   string    lpBinaryPathName;
   string    lpLoadOrderGroup;
   IntPtr    lpdwTagId;
   string    lpDependencies;
   string    lpServiceStartName;
   string    lpDisplayName;
  }
  //
  //Actions Structure
  //
  [StructLayout(LayoutKind.Sequential)]
  public struct SC_ACTION
  {
   SC_ACTION_TYPE SCActionType;
   uint            Delay;
  }
  //
  //Service description string Structure
  //
  [StructLayout(LayoutKind.Sequential)]
  public struct SERVICE_DESCRIPTION
  {
   string lpDescription;
  }
  //
  //Actions to take on service failure Structure
  //
  [StructLayout(LayoutKind.Sequential)]
  public struct SERVICE_FAILURE_ACTIONS
  {
   uint    dwResetPeriod;
   string  lpRebootMsg;
   string  lpCommand;
   uint    cActions;
   uint    lpsaActions;
  }
  //********************************************************************************
  [DllImport("kernel32.dll")]
  public static extern void CopyMemory(IntPtr pDst, SC_ACTION[] pSrc,uint ByteLen);
  
  [DllImport( "kernel32.dll")]
  public static extern uint GetLastError();
  
  [DllImport("advapi32.dll")]
  public static extern bool ChangeServiceConfig(uint    hService,
                                                uint    dwServiceType,
                                                uint    dwStartType,
                                                uint    dwErrorControl,
                                                string  lpBinaryPathName,
                                                string  lpLoadOrderGroup,
                                                IntPtr  lpdwTagId,
                                                string  lpDependencies,
                                                string  lpServiceStartName,
                                                string  lpPassword,
                                                string  lpDisplayName);
  
  [DllImport("advapi32.dll")]
  public static extern bool ChangeServiceConfig2A(uint        hService,
                                                  InfoLevel   dwInfoLevel,
                [MarshalAs(UnmanagedType.Struct)] ref SERVICE_DESCRIPTION  lpInfo);
  
  [DllImport("advapi32.dll")]
  public static extern bool ChangeServiceConfig2A(uint       hService,
                                                  InfoLevel  dwInfoLevel,
                [MarshalAs(UnmanagedType.Struct)] ref SERVICE_FAILURE_ACTIONS  lpInfo);
  
  [DllImport("advapi32.dll")]
  public static extern bool CloseServiceHandle(uint hSCObject);
  
  [DllImport("advapi32.dll", SetLastError=true)]
  public static extern bool ControlService(uint   hService,
                                           uint   dwControl,
                                           ref SERVICE_STATUS lpServiceStatus);
  
  [DllImport("advapi32.dll")]
  public static extern uint CreateService(uint    hSCManager,
                                            string  lpServiceName,
                                            string  lpDisplayName,
                                            uint    dwDesiredAccess,
                                            uint    dwServiceType,
                                            uint    dwStartType,
                                            uint    dwErrorControl,
                                            string  lpBinaryPathName,
                                            string  lpLoadOrderGroup,
                                            IntPtr  lpdwTagId,
                                            string  lpDependencies,
                                            string  lpServiceStartName,
                                            string  lpPassword);
  
  [DllImport("advapi32.dll")]
  public static extern bool DeleteService(uint hService);
  
  [DllImport("advapi32.dll")]
  public static extern bool EnumDependentServices(uint       hService,
                                                  uint       dwServiceState,
                                                  ref ENUM_SERVICE_STATUS  lpServices,
                                                  uint       cbBufSize,
                                                  ref uint   pcbBytesNeeded,
                                                  ref uint   lpServicesReturned );
  
  [DllImport("advapi32.dll")]
  public static extern bool EnumServicesStatus(uint     hSCManager,
                                               uint     dwServiceType,
                                               uint     dwServiceState,
                                               uint     lpServices,
                                               uint     cbBufSize,
                                               ref uint pcbBytesNeeded,
                                               ref uint lpServicesReturned,
                                               ref uint lpResumeHandle );
  
  [DllImport("advapi32.dll")]
  public static extern bool GetServiceKeyName(uint      hSCManager,
                                              string    lpDisplayName,
                                              string    lpServiceName,
                                              ref uint  lpcchBuffer);
  
  [DllImport("advapi32.dll")]
  public static extern bool GetServiceDisplayName(uint     hSCManager,
                                                  string   lpDisplayName,
                                                  string   lpServiceName,
                                                  ref uint lpcchBuffer);
  
  [DllImport("advapi32.dll")]
  public static extern bool LockServiceDatabase(uint hSCManager);
  
  [DllImport("advapi32.dll")]
  public static extern bool NotifyBootConfigStatus(bool BootAcceptable);
  
  [DllImport("advapi32.dll")]
  public static extern uint OpenSCManager(string  lpMachineName,
                                          string  lpDatabaseName,
                                          uint  dwDesiredAccess);
  
  [DllImport("advapi32.dll")]
  public static extern uint OpenService(uint    hSCManager,
                                        string  lpServiceName,
                                        uint    dwDesiredAccess);
  
  
  [DllImport("advapi32.dll")]
  public static extern bool QueryServiceConfigA(uint                       hService,
                                                [MarshalAs(UnmanagedType.Struct)] ref QUERY_SERVICE_CONFIG  lpServiceConfig,
                                                uint                       cbBufSize,
                                                uint                       pcbBytesNeeded);
  
  [DllImport("advapi32.dll")]
  public static extern bool QueryServiceStatus(uint                hService,
                                               ref SERVICE_STATUS  lpServiceStatus);
  
  [DllImport("advapi32")]
  public static extern bool StartService(uint         hService,
                                         uint         dwNumServiceArgs,
                                         string[]     lpServiceArgVectors);
  
  [DllImport("advapi32.dll")]
  public static extern bool UnlockServiceDatabase(uint hSCManager);
  //********************************************************************************
 }
}
